blob: 657df2cc134465d586a8b5dd71f968ba7bdb1a10 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Patrick Georgib890a122015-03-26 15:17:45 +010020# Foundation, Inc.
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Stefan Reinauerd7649122015-06-09 11:44:25 -070023cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010024
Stefan Reinauer682a90c2015-06-09 14:59:58 -070025CROSSGCC_DATE="June 17th, 2015"
26CROSSGCC_VERSION="1.31"
Stefan Reinauer074d9132009-09-26 16:43:17 +000027
28# default settings
Stefan Reinauer85b07d62015-06-09 14:45:14 -070029PACKAGE=GCC
Stefan Reinauerd7649122015-06-09 11:44:25 -070030TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000031TARGETARCH=i386-elf
32DESTDIR=
Stefan Reinauer85b07d62015-06-09 14:45:14 -070033SAVETEMPS=0
34SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000035
Stefan Reinauer699ac272015-06-05 12:43:28 -070036# GCC toolchain version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010037GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070038MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010039MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000040LIBELF_VERSION=0.8.13
Patrick Georgi53c388f2015-03-07 09:55:18 +010041GCC_VERSION=4.9.2
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070042GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010043BINUTILS_VERSION=2.25
Stefan Reinauerbed95b22015-06-09 13:41:40 -070044GDB_VERSION=7.9.1
Patrick Georgi53c388f2015-03-07 09:55:18 +010045IASL_VERSION=20150204
46PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020047EXPAT_VERSION=2.1.0
Stefan Reinauer14ce2132015-06-05 13:01:13 -070048# CLANG version number
49CLANG_VERSION=3.6.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000050
Stefan Reinauer699ac272015-06-05 12:43:28 -070051# GCC toolchain archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010052GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020053MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020054MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000055LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020056GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070057BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010058GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
59IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
60PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010061EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070062# CLANG toolchain archive locations
63LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
64CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
65CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
66CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000067
Stefan Reinauer699ac272015-06-05 12:43:28 -070068# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000069GMP_DIR="gmp-${GMP_VERSION}"
70MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000071MPC_DIR="mpc-${MPC_VERSION}"
72LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000073GCC_DIR="gcc-${GCC_VERSION}"
74BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
75GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060076IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010077PYTHON_DIR="Python-${PYTHON_VERSION}"
78EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070079# CLANG toolchain directories
80LLVM_DIR="llvm-${CLANG_VERSION}.src"
81CFE_DIR="cfe-${CLANG_VERSION}.src"
82CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
83CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauer074d9132009-09-26 16:43:17 +000084
Patrick Georgi6321f522015-02-27 23:36:26 +010085unset MAKELEVEL MAKEFLAGS
86
Patrick Georgi1861ff72011-10-31 12:15:55 +010087red='\033[0;31m'
88RED='\033[1;31m'
89green='\033[0;32m'
90GREEN='\033[1;32m'
91blue='\033[0;34m'
92BLUE='\033[1;34m'
93cyan='\033[0;36m'
94CYAN='\033[1;36m'
95NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000096
Stefan Reinauerd7649122015-06-09 11:44:25 -070097UNAME=$(uname)
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070098
Patrick Georgi198d23c2012-12-08 08:02:44 +010099normalize_dirs()
100{
101 mkdir -p $DESTDIR$TARGETDIR/lib
102 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
103 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
104 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
105
106 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
107 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
108}
109
Stefan Reinauer93a96302015-06-15 12:36:53 -0700110please_install()
111{
112 test -r /etc/os-release && source /etc/os-release
113 case "$ID_LIKE" in
114 debian) solution="sudo apt-get install $1" ;;
115 suse) solution="sudo zypper install $1" ;;
116 *) solution="using your OS packaging system" ;;
117 esac
118
119 printf "${RED}ERROR:${red} Missing tool: Please install \'$1\' utility. (eg $solution)${NC}\n" >&2
120}
121
Patrick Georgib7062882015-02-24 10:52:14 +0100122searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000123{
124 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100125 # $2 search string
126 # $3 soft fail if set
127 # result: file name of that tool on stdout
128 # or no output if nothing suitable was found
129 search=GNU
130 if [ -n "$2" ]; then
131 search="$2"
132 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000133 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700134 if [ -x "$(which $i 2>/dev/null)" ]; then
135 if [ "$(cat /dev/null | $i --version 2>&1 | grep -c "$search")" \
136 -gt 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000137 echo $i
138 return
139 fi
140 fi
141 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800142 # A workaround for OSX 10.9 and some BSDs, whose nongnu
143 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200144 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100145 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700146 if [ -x "$(which $1 2>/dev/null)" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800147 echo $1
148 return
149 fi
150 fi
151 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700152 if [ "$(echo $1 | cut -b -3)" = "sha" ]; then
zbao939dc842015-04-30 04:44:07 +0800153 if [ $UNAME = "FreeBSD" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700154 if [ -x "$(which sha1 2>/dev/null)" ]; then
zbao939dc842015-04-30 04:44:07 +0800155 echo sha1
156 return
157 fi
158 fi
159 if [ $UNAME = "NetBSD" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700160 if [ -x "$(which cksum 2>/dev/null)" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700161 echo cksum -a $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800162 return
163 fi
164 fi
165 if [ $UNAME = "Darwin" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700166 if [ -x "$(which openssl 2>/dev/null)" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700167 echo openssl $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800168 return
169 fi
170 fi
171 fi
Stefan Reinauer93a96302015-06-15 12:36:53 -0700172 please_install $1
Patrick Georgib7062882015-02-24 10:52:14 +0100173 [ -z "$3" ] && exit 1
174 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000175}
176
Stefan Reinauer88935482015-06-05 09:51:10 -0700177download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700178 package=$1
179 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700180
Stefan Reinauerd7649122015-06-09 11:44:25 -0700181 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700182 printf " * $FILE "
183
184 test -f tarballs/$FILE && \
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700185 ( test -z "$CHECKSUM" || \
186 test "$(cat sum/$FILE.cksum 2>/dev/null | \
187 sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" = \
188 "$($CHECKSUM tarballs/$FILE 2>/dev/null | \
189 sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" ) && \
Stefan Reinauer88935482015-06-05 09:51:10 -0700190 printf "(cached)" || (
191 printf "(downloading)"
192 rm -f tarballs/$FILE
193 cd tarballs
Stefan Reinauer699ac272015-06-05 12:43:28 -0700194 wget --no-check-certificate -q $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700195 cd ..
196 test ! -f sum/$FILE.cksum && test -f tarballs/$FILE && \
197 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$FILE > sum/$FILE.cksum ) && \
198 printf "(checksum created. ${RED}Note. Please upload sum/$FILE.cksum if the corresponding archive is upgraded.${NC})"
199 )
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700200 if [ ! -f tarballs/$FILE ]; then
Stefan Reinauer88935482015-06-05 09:51:10 -0700201 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700202 exit 1
203 fi
Stefan Reinauer88935482015-06-05 09:51:10 -0700204 printf "\n"
205}
206
207unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700208 package=$1
209 archive="$(eval echo \$$package"_ARCHIVE")"
210 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700211 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700212 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700213 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700214 suffix=$(echo $archive | sed 's,.*\.,,')
Stefan Reinauer88935482015-06-05 09:51:10 -0700215 test "$suffix" = "gz" && FLAGS=zxf
216 test "$suffix" = "bz2" && FLAGS=jxf
217 test "$suffix" = "xz" && FLAGS="--xz -xf"
218 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauerd7649122015-06-09 11:44:25 -0700219 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700220 for patch in patches/${dir}_*.patch; do
221 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700222 printf " o $(basename $patch)\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700223 $PATCH -s -N -p0 < $(echo $patch) || {
Stefan Reinauer88935482015-06-05 09:51:10 -0700224 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700225 exit 1
226 }
Stefan Reinauer88935482015-06-05 09:51:10 -0700227 done
228 touch ${dir}/.unpack_success
229 )
230}
231
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700232fn_exists()
233{
Patrick Georgic8665912015-06-11 21:04:31 +0200234 type $1 >/dev/null 2>&1
Patrick Georgi74c06422015-03-25 18:40:13 +0100235}
236
Patrick Georgif2c15f52015-06-11 21:07:31 +0200237is_package_enabled()
238{
239 echo "$PACKAGES" |grep -q "\<$1\>"
240}
241
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700242build() {
243 package=$1
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700244
245 fn_exists build_$package || return
246
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700247 version="$(eval echo \$$package"_VERSION")"
248 BUILDDIR=build-${TARGETARCH}-$package
249
250 mkdir -p ${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700251
Patrick Georgif2c15f52015-06-11 21:07:31 +0200252 is_package_enabled "$package" && \
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700253 if [ -f ${BUILDDIR}/.success ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700254 printf "Skipping $package as it is already built\n"
255 else
256 printf "Building $package $version ... "
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700257 DIR=$PWD
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700258 cd ${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700259 rm -f .failed
260 build_${package} > build.log 2>&1
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700261 cd $DIR/${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700262 if [ ! -f .failed ]; then touch .success; fi
263 cd ..
264
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700265 if [ -r "${BUILDDIR}/.failed" ]; then
266 printf "${RED}failed${NC}. Check ${BUILDDIR}/build.log.\n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700267 exit 1
268 fi
269 printf "${green}ok${NC}\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700270 fi
271}
272
Stefan Reinauer074d9132009-09-26 16:43:17 +0000273cleanup()
274{
275 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700276 for package in $PACKAGES; do
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700277 rm -rf build-${TARGETARCH}-$package $(eval echo \$$package"_DIR")
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700278 done
Stefan Reinauer074d9132009-09-26 16:43:17 +0000279 printf "${green}ok${NC}\n"
280}
281
282myhelp()
283{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700284 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000285 printf " $0 [-V|--version]\n"
286 printf " $0 [-h|--help]\n\n"
287
288 printf "Options:\n"
289 printf " [-V|--version] print version number and exit\n"
290 printf " [-h|--help] print this help and exit\n"
291 printf " [-c|--clean] remove temporary files before build\n"
292 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100293 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000294 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000295 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
296 printf " (defaults to $TARGETDIR)\n\n"
297 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100298 printf " (for RPM builds, default unset)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700299 printf " [-P|--package <package>] Build a specific package: GCC, CLANG, IASL, GDB\n"
300 printf " (defaults to $PACKAGE)\n"
301 printf "GCC specific options:\n"
302 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
303 printf " (defaults to $TARGETARCH)\n"
304 printf "GDB specific options:\n"
305 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
306 printf " (defaults to $TARGETARCH)\n"
307 printf " [-S|--scripting] build scripting support for GDB\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000308}
309
310myversion()
311{
312 # version tag is always printed, so just print the license here
313
314 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000315Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600316Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000317
318This program is free software; you can redistribute it and/or modify
319it under the terms of the GNU General Public License as published by
320the Free Software Foundation; version 2 of the License.
321
322This program is distributed in the hope that it will be useful,
323but WITHOUT ANY WARRANTY; without even the implied warranty of
324MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
325GNU General Public License for more details.
326
327EOF
328}
329
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700330build_GMP() {
331 CC="$CC" CFLAGS="-Os" ../${GMP_DIR}/configure --disable-shared --enable-fat --prefix=$TARGETDIR $OPTIONS \
332 || touch .failed
333 $MAKE $JOBS || touch .failed
334 $MAKE install DESTDIR=$DESTDIR || touch .failed
335
336 normalize_dirs
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700337
338 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
339 # as GCC 4.6.x fails if it's there.
340 export HOSTCFLAGS=$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
341 sed s,-pedantic,,)
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700342}
343
344build_MPFR() {
345 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
346 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
347 --infodir=$TARGETDIR/info \
348 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
349 touch .failed
350 $MAKE $JOBS || touch .failed
351 $MAKE install DESTDIR=$DESTDIR || touch .failed
352
353 normalize_dirs
354
355 # work around build problem of libgmp.la
356 if [ "$DESTDIR" != "" ]; then
357 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
358 fi
359}
360
361build_MPC() {
362 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
363 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
364 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
365 touch .failed
366 $MAKE $JOBS || touch .failed
367 $MAKE install DESTDIR=$DESTDIR || touch .failed
368
369 normalize_dirs
370}
371
372build_LIBELF() {
373 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
374 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
375 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
376 $MAKE $JOBS || touch .failed
377 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
378
379 normalize_dirs
380}
381
382build_BINUTILS() {
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700383 if [ $TARGETARCH == "x86_64-elf" ]; then
384 ADDITIONALTARGET=",i386-elf"
385 fi
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700386 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700387 --target=${TARGETARCH} --enable-targets=${TARGETARCH}${ADDITIONALTARGET} \
388 --disable-werror --disable-nls --enable-lto --enable-gold \
389 --enable-plugins --enable-multilibs CFLAGS="$HOSTCFLAGS" || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700390 $MAKE $JOBS || touch .failed
391 $MAKE install DESTDIR=$DESTDIR || touch .failed
392}
393
394
395build_GCC() {
Stefan Reinauerd0f83722015-06-09 11:52:28 -0700396 # GCC does not honor HOSTCFLAGS at all. CFLAGS are used for
397 # both target and host object files.
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700398 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
399 # but it does not seem to work properly. At least the host library
400 # libiberty is not compiled with CFLAGS_FOR_BUILD.
401 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
402 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
403 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
404 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700405 --enable-lto --enable-plugins --enable-gold --enable-ld=default \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700406 --disable-libssp --disable-bootstrap --disable-nls \
407 --disable-libquadmath --without-headers \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700408 ${GCC_OPTIONS} --enable-languages="c" \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700409 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
410 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
411 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
412 || touch .failed
413 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
414 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
415
Stefan Reinauerd7649122015-06-09 11:44:25 -0700416 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700417 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
418 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
419 fi
420}
421
422build_EXPAT() {
423 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
424 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
425 $MAKE || touch .failed
426 $MAKE install DESTDIR=$DESTDIR || touch .failed
427
428 normalize_dirs
429}
430
431build_PYTHON() {
432 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
433 --target=${TARGETARCH} || touch .failed
434 $MAKE $JOBS || touch .failed
435 $MAKE install DESTDIR=$DESTDIR || touch .failed
436
437 normalize_dirs
438}
439
440build_GDB() {
441 export PYTHONHOME=$DESTDIR$TARGETDIR
442 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
443 LIBDL="-ldl"
444 fi
445 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
446 -lpthread $LIBDL -lutil" \
447 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer7b40e422015-06-09 11:56:32 -0700448 ../${GDB_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700449 --target=${TARGETARCH} --disable-werror --disable-nls
450 $MAKE $JOBS || touch .failed
451 $MAKE install DESTDIR=$DESTDIR || touch .failed
452}
453
454build_IASL() {
455 RDIR=$PWD
456 cd ../$IASL_DIR/generate/unix
457 CFLAGS="$HOSTCFLAGS"
458 HOST="_LINUX"
459 test $UNAME = "Darwin" && HOST="_APPLE"
460 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
461 test $UNAME = "Cygwin" && HOST="_CYGWIN"
462 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
463 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
464 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
465}
466
467build_LLVM() {
468 cd ..
469 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
470 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
471 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
472 cd -
473
474 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
475 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
476 $MAKE $JOBS || touch .failed
477 $MAKE install || touch .failed
478
479 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
480 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
481}
482
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700483printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000484
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000485# Look if we have getopt. If not, build it.
486export PATH=$PATH:.
487getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
488
Stefan Reinauer074d9132009-09-26 16:43:17 +0000489# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700490getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200491if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000492 # Detected GNU getopt that supports long options.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700493 args=$(getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache,clang Vhcd:p:j:D:tGyC -- "$@")
Stefan Reinauer074d9132009-09-26 16:43:17 +0000494 eval set "$args"
495else
496 # Detected non-GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700497 args=$(getopt Vhcd:p:j:D:tGyC $*)
Stefan Reinauer074d9132009-09-26 16:43:17 +0000498 set -- $args
499fi
500
501if [ $? != 0 ]; then
502 myhelp
503 exit 1
504fi
505
506while true ; do
507 case "$1" in
508 -V|--version) shift; myversion; exit 0;;
509 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100510 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000511 -t|--savetemps) shift; SAVETEMPS=1;;
512 -d|--directory) shift; TARGETDIR="$1"; shift;;
513 -p|--platform) shift; TARGETARCH="$1"; shift;;
514 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000515 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700516 -P|--package) shift; PACKAGE="$1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100517 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100518 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200519 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000520 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200521 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000522 esac
523done
524
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700525case "$TARGETARCH" in
Stefan Reinauer24f9cb92015-03-13 22:50:22 +0100526 x86_64-elf) ;;
527 x86_64*) TARGETARCH=x86_64-elf;;
David Hubbard5b0420a2013-05-28 16:33:15 -0600528 i386-elf) ;;
529 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100530 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100531 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700532 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200533 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700534 aarch64*) TARGETARCH=aarch64-elf;;
535 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700536esac
537
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700538# Figure out which packages to build
Stefan Reinauer699ac272015-06-05 12:43:28 -0700539
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700540case "$PACKAGE" in
541 GCC|gcc)
542 echo "Target architecture is now $TARGETARCH"
543 NAME="${TARGETARCH} cross GCC"
Stefan Reinauerbd8b2e32015-06-17 11:55:02 -0700544 PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700545 ;;
546 GDB|gdb)
547 NAME="${TARGETARCH} cross GDB"
548 PACKAGES="GDB"
549 if [ $SKIPPYTHON -eq 0 ]; then
550 PACKAGES="EXPAT PYTHON $PACKAGES"
551 fi
552 ;;
553 CLANG|clang)
554 NAME=clang
555 PACKAGES="LLVM CFE CRT CTE"
David Hendrickscd5cdd32015-06-15 17:03:22 -0700556 CMAKE=$(searchtool cmake "cmake") || exit $?
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700557 ;;
558 IASL|iasl)
559 NAME="IASL ACPI compiler"
560 PACKAGES=IASL
561 ;;
562 *)
563 printf "${red}ERROR: Unsupported package $PACKAGE. (Supported packages are GCC, GDB, CLANG, IASL)${NC}\n\n";
564 exit 1
565 ;;
566esac
Peter Stugeceacd772011-06-09 04:54:16 +0200567
Stefan Reinauer66e93352015-06-16 22:38:23 +0200568# Find all the required tools:
569
570TAR=$(searchtool tar) || exit $?
571PATCH=$(searchtool patch) || exit $?
572MAKE=$(searchtool make) || exit $?
573SHA1SUM=$(searchtool sha1sum)
574SHA512SUM=$(searchtool sha512sum)
575CHECKSUM=$SHA1SUM
576
577searchtool m4 > /dev/null
578searchtool bison > /dev/null
579searchtool flex flex > /dev/null
580searchtool g++ "Free Software Foundation" nofail > /dev/null || \
581searchtool clang "clang version" > /dev/null
582searchtool wget > /dev/null
583searchtool bzip2 "bzip2," > /dev/null
584
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700585# This initial cleanup is useful when updating the toolchain script.
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000586
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700587if [ "$clean" = "1" ]; then
588 cleanup
589fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000590
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700591# Set up host compiler and flags needed for various OSes
Stefan Reinauer074d9132009-09-26 16:43:17 +0000592
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700593CC=cc
Patrick Georgif2c15f52015-06-11 21:07:31 +0200594if is_package_enabled "GCC"; then
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700595if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000596 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
597
598 # generally the OS X compiler can create x64 binaries.
599 # Per default it generated i386 binaries in 10.5 and x64
600 # binaries in 10.6 (even if the kernel is 32bit)
601 # For some weird reason, 10.5 autodetects an ABI=64 though
602 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700603 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000604 OPTIONS="ABI=64"
605 else
606 OPTIONS="ABI=32"
607 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700608
Stefan Reinauer4266b922012-12-05 16:18:32 -0800609 # In Xcode 4.5.2 the default compiler is clang.
610 # However, this compiler fails to compile gcc 4.7.x. As a
611 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700612 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800613 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700614 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000615fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700616fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000617
Patrick Georgic1a75b12011-11-04 21:37:14 +0100618if [ "$USECCACHE" = 1 ]; then
619 CC="ccache $CC"
620fi
621
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700622# Prepare target directory for building GCC
623# (dependencies must be in the PATH)
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100624mkdir -p $DESTDIR$TARGETDIR/bin
625export PATH=$DESTDIR$TARGETDIR/bin:$PATH
626
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700627# Download, unpack, patch and build all packages
628
629printf "Downloading tar balls ... \n"
630mkdir -p tarballs
631for P in $PACKAGES; do
632 download $P
633done
634printf "Downloaded tar balls ... ${green}ok${NC}\n"
635
636printf "Unpacking and patching ... \n"
637for P in $PACKAGES; do
638 unpack_and_patch $P || exit 1
639done
640printf "Unpacked and patched ... ${green}ok${NC}\n"
641
642printf "Building packages ... \n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700643for package in $PACKAGES; do
644 build $package
645done
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700646printf "Packages built ... ${green}ok${NC}\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700647
Stefan Reinauer699ac272015-06-05 12:43:28 -0700648# Adding git information of current tree to target directory
649# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -0700650PROGNAME=$(basename "$0")
Patrick Georgi5602f2c2015-03-28 15:48:47 +0100651rm -f "$DESTDIR$TARGETDIR/$PROGNAME".commit.*
Stefan Reinauerd7649122015-06-09 11:44:25 -0700652cp "$PROGNAME" $DESTDIR$TARGETDIR/"$PROGNAME.commit.$(git describe)"
Zheng Bao30b895f2013-02-06 18:04:40 +0800653
Stefan Reinauer074d9132009-09-26 16:43:17 +0000654if [ $SAVETEMPS -eq 0 ]; then
Stefan Reinauer699ac272015-06-05 12:43:28 -0700655 cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000656else
657 printf "Leaving temporary files around... ${green}ok${NC}\n"
658fi
659
Stefan Reinauer699ac272015-06-05 12:43:28 -0700660printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"